# Summary

|  | Main Programming Language | Type of Bugs/Errors | Usage of OpenAPI | Research Goals | Found Bugs/Errors | Highest Code Coverage | Notes |   
|---|---|---|---|---|---|---|---|
| Specification-based Approach | Java | - Nominal Test Cases : 4xx/500 Status Codes, Schema Errors <br> - Faulty Test Cases : 500, 200 Status Codes | Yes | - High level coverage <br> - Finding main failing points  | 37 in the 91 selected APIs | - Operations : 87% <br> - Parameters : 62% <br> - Endpoints : 81% <br> - Definitions : 76% | |
| Property-based Approach (QuickREST) | Clojure | 500 Status Codes | Yes | - Behavior of several stateless generators <br> - Behavior of stateful generators and stateless generators <br> - Addition related to finding faults |  | - Response Code Coverage of POST Method <br> - 201 : 86.5% <br> - 400 : 83.6% <br> - 500 : 16.4% | - Found that several of the service APIs are under-specified |
| Search-based Approach (EvoMaster) | Kotlin | 5xx Status Codes | Yes | - Find real bugs <br> - Compare code coverage to manual tests <br> - Find main factors for better results | 39 real bugs | 41% (18%, 20%, 41%) | Main factors for better results : String constraints, accesses to databases, external web services |
| Constraint-based Approach (RESTest) | Java | - 5XX Status Codes <br> - OpenAPI Schema Errors <br> - 2XX Related to Parameters <br> - 2XX Related to Parameter Dependencies <br> - 4XX Status Codes | Yes | - Find out the effectiveness in generating valid test cases <br> - Find out the effectiveness in fault-finding to selected APIs | 1358 new bugs in comparison with random test cases ( 2920 -> 4278 ) | | |
| Resource-based Approach | Kotlin |   |   | - Find out that this approach gives improvement <br> - Find out which of presented techniques gives best results | | | - Improvement in 6 of 7 case studies <br> - MIO performs better |
| Operation Dependency Graph Approach (RESTTESTGEN) | Java | - Nominal Cases : 5xx Status Codes or Validation Error of Response <br> - Error Cases : 2xx or 5xx Status Codes | Yes | - Find out how effective the proposed Nominal Test Generator is <br> - Find out how effective the proposed Error Test Generator is | - Nominal Cases : 151 Faults, 1733 response validation errors <br> - Error Cases : 864 cases are accepted, 23 cases with unhandled errors |  | |
| Stateful Fuzzing Approach (RESTler) | Python |  | Yes | - Find out how effective proposed techniques are (inferring dependencies among request types, analyzing dynamic feedback) <br> - Find out if RESTler exercises deeper as sequence length increases <br> - Compare three proposed search strategies in terms of code coverage | 28 bugs in GitLab, several bugs in Azure, Office 365 cloud service | no percentages or total number given |  |
